# SINDO

SINDO is a suite of programs for molecular vibrational analysis.

- JSindo: Viewer of molecules and modes  
  - Import the output of quantum chemistry program  
  - Harmonic analysis  
     - Harmonic frequencies  
     - IR intensity  
     - Normal modes  
  - Localized modes  

- RunMakePES: Generator of anharmonic potential
  - nMR expansion (n=1-4)
  - QFF generation
  - Grid-PES based on HO-DVR
  - Hybrid PES
  - Implementation for parallel execution
  - Interface with quantum chemistry programs

- SINDO: Solver of vibrational Schr&ouml;dinger equation
  - Multiresolution PES
  - optimized-coordinate-VSCF
  - VSCF
  - VCI[m]-(k)
  - VMP2-(k)
  - VQDPT2-(k)
  - Infrared intensities and spectrum

## Acknowledgment ##
Dr. Hiroya Asami (Gakushuin Univ.)  
Prof. Masaaki Fujii (Tokyo Institute of Technology)  
Prof. Hiroshi Fujisaki (Nippon Medical School)  
Prof. So Hirata (Univ. of Illinois at Urbana-Champaign)  
Dr. Wataru Mizukami (Kyushu Univ.)  
Dr. Hiroki Otaki (Nagasaki Univ.)  
Dr. Yuji Sugita (RIKEN)  

## Grant-in-aid ##  
2007-2012 Scientific Research (KAKENHI) on Priority Areas (477) “Molecular Science for Supra Functional Systems” supported by MEXT, Japan.  
2017-2018 Grant-in-Aid for Scientific Research on Innovative Areas (2503) “Science on Function of Soft Molecular Systems by Cooperation of Theory and Experiment" supported by MEXT, Japan.  

